/*
 * Vorlesung ``Data Processing on Modern Hardware''
 *
 * Uebungsblatt 2
 *
 * Implementation eines einfachen `column store'; basierend
 * auf einer Implementation von Rene Mueller, ETH Zuerich.
 */
#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <sys/time.h>
#include <time.h>

#include "schema.h"
#include "load.h"


int 
main(int argc, char **argv)
{
    uint32_t    numrows; 
    struct      timeval start, end;

    /* columns */
    uint32_t    *orderkey, *partkey, *suppkey;
    int32_t     *linenumber;
    int64_t     *quantity, *extendedprice, *discount, *tax;
    char        *returnflag, *linestatus;
    uint32_t    *shipdate, *commitdate, *receiptdate;
    char        *shipinstruct, *shipmode, *comment;

    /* load input data */
    printf("loading data file \"%s\"...\n", DATA_FILE); 
    gettimeofday(&start, NULL); 
    if (load_lineitems_columns(
                DATA_FILE, &numrows,
                &orderkey, &partkey, &suppkey, 
                &linenumber, &quantity, &extendedprice,
                &discount, &tax, &returnflag, 
                &linestatus, &shipdate, &commitdate, 
                &receiptdate, &shipinstruct, &shipmode, &comment))
    {
        fprintf(stderr, "error while reading data file: \"%s\"\n", DATA_FILE);
        exit(1); 
    }

    gettimeofday(&end, NULL); 

    printf("read %u rows in %d seconds\n", numrows, 
            (int)(end.tv_sec-start.tv_sec));


    /* 
     * Fuegen Sie hier den Code fuer die folgende SQL-Anweisung ein
     *
     *    SELECT sum(orderkey + linenumber*shipdate)
     *    FROM lineitems
     */


    /* cleanup before exit */
    free(orderkey);
    free(partkey);
    free(suppkey);
    free(linenumber);
    free(quantity);
    free(extendedprice);
    free(discount);
    free(tax);
    free(returnflag); 
    free(linestatus);
    free(shipdate);
    free(commitdate);
    free(receiptdate);
    free(shipinstruct);
    free(shipmode);
    free(comment);
    return 0;
}


