/*
 * Vorlesung ``Data Processing on Modern Hardware''
 *
 * Uebungsblatt 2
 *
 * Implementation eines einfachen `row store'; basierend
 * auf einer Implementation von Rene Mueller, ETH Zuerich.
 */
#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <sys/time.h>
#include <time.h>

#include "schema.h"
#include "load.h"


int 
main(int argc, char **argv)
{
    uint32_t    numrows; 
    struct      timeval start, end;
    lineitem_t  *firstrow;

    /* load input data */
    printf("loading data file \"%s\"...\n", DATA_FILE); 

    gettimeofday(&start, NULL); 

    if (load_lineitems_rows(DATA_FILE, &firstrow, &numrows))
    {
        fprintf(stderr, "error while reading data file: \"%s\"\n", DATA_FILE);
        exit(1); 
    }

    gettimeofday(&end, NULL); 

    printf("read %u rows in %d seconds\n", numrows, 
            (int)(end.tv_sec-start.tv_sec));

    /*
     * Fuegen Sie hier bitte den Code fuer die SQL-Anweisung ein
     *
     *    SELECT sum(orderkey + linenumber*shipdate)
     *    FROM lineitems
     */


    /* cleanup before exit */
    free(firstrow); /* free row memory */
    return 0;
}


